﻿using System.Diagnostics;
using System.Xml.Linq;

namespace Kolory.Model
{
    public class Stan
    {
        public double R = 0, G = 0, B = 0;

        #region Pliki
        private static string ścieżkaPliku =
            Path.Combine(
                Environment.GetFolderPath(Environment.SpecialFolder.UserProfile),
                "ustawienia.xml");

        private static IFormatProvider fp = System.Globalization.CultureInfo.InvariantCulture;

        public static Stan CzytajZPlikuXml() //pseudokonstruktor
        {
            try
            {
                XDocument xml = XDocument.Load(ścieżkaPliku);
                double r = double.Parse(xml.Root.Element("r").Value, fp);
                double g = double.Parse(xml.Root.Element("g").Value, fp);
                double b = double.Parse(xml.Root.Element("b").Value, fp);
                return new Stan() { R = r, G = g, B = b };
            }
            catch
            {
                return new Stan();
            }
        }

        public void ZapiszDoPlikuXml()
        {
            XDocument xml = new XDocument(
                new XDeclaration("1.0", "utf-8", "yes"),
                new XComment("Data zapisu: " + DateTime.Now.ToString()),
                new XElement("ustawienia",
                    new XElement("r", R.ToString(fp)),
                    new XElement("g", G.ToString(fp)),
                    new XElement("b", B.ToString(fp))
                )
            );

            try
            {
                xml.Save(ścieżkaPliku);
            }
            catch (Exception exc)
            {
                Debug.WriteLine($"Nie udało się zapisać stanu aplikacji. Błąd: {exc.Message}");
            }
        }
        #endregion
    }
}
